<?php

namespace Configuration\Patch;

use Configuration\DatabaseScript;
use Driver\SQL\SQL;

class db_htb extends DatabaseScript {

  public static function createQueries(SQL $sql) {

    $queries = array();
    $queries[] = $sql->createTable("HackTheBoxMachine")
      ->onlyIfNotExists()
      ->addSerial("uid")
      ->addDateTime("lastChecked", false, $sql->now())
      ->addString("name", 16)
      ->addString("os", 16)
      ->addBool("retired", false)
      ->addString("avatar", 256)
      ->addDateTime("releaseDate")
      ->addInt("points")
      ->addString("difficulty", 16)
      ->primaryKey("uid");

    $queries[] = $sql->createTable("HackTheBoxUser")
      ->onlyIfNotExists()
      ->addInt("uid")
      ->addString("name", 32)
      ->addBool("confirmed", false)
      ->addString("token",  24)
      ->addDateTime("registered", false, $sql->now())
      ->primaryKey("uid")
      ->unique("token");

    $queries[] = $sql->createTable("HackTheBoxMachineOwn")
      ->onlyIfNotExists()
      ->addInt("user_id")
      ->addInt("machine_id")
      ->addEnum("type", array("user","root"))
      ->foreignKey("user_id", "HackTheBoxUser", "uid")
      // ->foreignKey("machine_id", "HackTheBoxMachine", "uid")
      ->unique("user_id", "machine_id", "type");

    $queries[] = $sql->createTable("HackTheBoxWriteupAccess")
      ->onlyIfNotExists()
      ->addInt("machine_id")
      ->addInt("user_id")
      ->addDateTime("visited", false, $sql->now())
      ->addBool("user")
      ->addBool("root")
      ->addString("ipAddress", 45, false, ""); // i should check law here…

    return $queries;
  }
}
